//
// JSToken.cs:
//
// Author: Cesar Octavio Lopez Nataren
//
// (C) 2003, Cesar Octavio Lopez Nataren, <cesar@ciencias.unam.mx>
//

namespace Microsoft.JScript {

	public enum JSToken : int {
		None = -1,
		EndOfFile,
		
		If,
		For,
		Do,
		While,
		Continue,
		Break,
		Return,
		Import,
		With,
		Switch,
		Throw,
		Try,
		Package,
		Internal,
		Abstract,
		Public,
		Static,
		Private,
		Protected,
		Final,
		Event,
		Var,
		Const,
		Class,

		Function,
		LeftCurly,
		Semicolon,

		Null,
		True,
		False,
		This,
		Identifier,
		StringLiteral,
		IntegerLiteral,
		NumericLiteral,

		LeftParen,
		LeftBracket,
		AccessField,

		// Operators

		FirstOp,
		LogicalNot = FirstOp,
		BitwiseNot,
		Delete,
		Void,
		Typeof,
		Increment,
		Decrement,
		
		FirstBinaryOp,
		Plus = FirstBinaryOp,
		Minus,
		LogicalOr,
		LogicalAnd,
		BitwiseOr,
		BitwiseXor,
		BitwiseAnd,
		Equal,
		NotEqual,
		StrictEqual,
		StrictNotEqual,
		GreaterThan,
		LessThan,
		LessThanEqual,
		GreaterThanEqual,
		LeftShift,
		RightShift,
		UnsignedRightShift,
		Multiply,
		Divide,
		Modulo,
		LastPPOperator = Modulo,
		InstanceOf,
		In,
		Assign,
		PlusAssign,
		MinusAssign,
		MultiplyAssign,
		DivideAssign,
		BitwiseAndAssign,
		BitwiseOrAssign,
		BitwiseXorAssign,
		ModuloAssign,
		LeftShiftAssign,
		RightShiftAssign,
		UnsignedRightShiftAssign,
		LastAssign = UnsignedRightShiftAssign,
		LastBinaryOp = UnsignedRightShiftAssign,
		ConditionalIf,
		Colon,
		Comma,
		LastOp = Comma,

		Case,
		Catch,
		Debugger,
		Default,
		Else,
		Export,
		Extends,
		Finally,
		Get,
		Implements,
		Interface,
		New,
		Set,
		Super,
		RightParen,
		RightCurly,
		RightBracket,
		PreProcessorConstant,
		Comment,
		UnterminatedComment,

		// Reserved words

		Assert,
		Boolean,
		Byte,
		Char,
		Decimal,
		Double,
		DoubleColon,
		Enum,
		Ensure,
		Float,
		Goto,
		Int,
		Invariant,
		Long,
		Namespace,
		Native,
		Require,
		Sbyte,
		Short,
		Synchronized,
		Transient,
		Throws,
		ParamArray,
		Volatile,
		Ushort,
		Uint,
		Ulong,
		Use,

		EndOfLine,
		PreProcessDirective		
	}
}
