//
// System.ComponentModel.Design.ActiveDesignerEventArgs.cs
//
// Author:
// 	Alejandro Snchez Acosta  <raciel@es.gnu.org>
//
// (C) Alejandro Snchez Acosta
// 

using System.Runtime.Serialization;

namespace System.ComponentModel.Design
{
	public class ActiveDesignerEventArgs : EventArgs
	{
		private IDesignerHost oldDesigner;
		private IDesignerHost newDesigner;
		
		public ActiveDesignerEventArgs (IDesignerHost oldDesigner, IDesignerHost newDesigner) {
			this.oldDesigner = oldDesigner;
			this.newDesigner = newDesigner;
		}

		public IDesignerHost NewDesigner {
			get {
				return newDesigner;
			}
		}

		public IDesignerHost OldDesigner {
			get {
				return oldDesigner;
			}		
		}
	}
}
